import { CompletionList, Hover, SymbolInformation, DocumentSymbolParams, TextEdit, DocumentHighlight, DocumentLink } from 'vscode-languageserver-types';
import { LanguageService, HTMLDocument } from 'vscode-html-languageservice';
import { TextDocumentPositionParams, DocumentRangeFormattingParams } from 'vscode-base-languageclient';
export declare class HtmlService {
    private openedDocumentUris;
    protected readonly htmlService: LanguageService;
    readonly documents: any;
    onInitialize: () => {
        capabilities: {
            completionProvider: boolean;
            hoverProvider: boolean;
            documentHighlightProvider: boolean;
            documentRangeFormattingProvider: boolean;
            documentLinkProvider: boolean;
            documentSymbolProvider: boolean;
            signatureHelpProvider: {
                triggerCharacters: string[];
            };
            referencesProvider: boolean;
            colorProvider: boolean;
        };
    };
    onDidOpenTextDocument: (params: any) => void;
    onDidChangeTextDocument: (params: any) => void;
    onDidCloseTextDocument: (params: any) => Promise<void>;
    onDocumentFormatting(params: DocumentRangeFormattingParams): TextEdit[];
    onDocumentSymbol(params: DocumentSymbolParams): SymbolInformation[];
    onDocumentHighlight(params: any): DocumentHighlight[];
    onDocumentLinks(params: any): DocumentLink[];
    onHover(params: TextDocumentPositionParams): Hover | null;
    onCompletion(params: TextDocumentPositionParams): CompletionList;
    getHTMLDocument(document: any): HTMLDocument;
    private getOpenDocument;
}
