import { CompletionItem, DocumentSymbolParams, TextEdit } from 'vscode-languageserver-types';
import { LanguageService, JSONDocument } from 'vscode-json-languageservice';
import { TextDocumentPositionParams, DocumentRangeFormattingParams, ExecuteCommandParams } from 'vscode-base-languageclient';
import { TextDocuments } from 'vscode-languageserver';
export declare class JsonService {
    private openedDocumentUris;
    private activated;
    private activation;
    protected readonly jsonService: LanguageService;
    protected readonly pendingValidationRequests: Map<string, number>;
    readonly documents: TextDocuments;
    constructor();
    onInitialize(params: any): {
        capabilities: {
            completionProvider: boolean;
            hoverProvider: boolean;
            documentSymbolProvider: boolean;
            documentFormattingProvider: boolean;
            textDocumentSync: boolean;
            definitionProvider: boolean;
            referencesProvider: boolean;
            workspaceSymbolProvider: boolean;
            documentHighlightProvider: boolean;
            documentLinkProvider: boolean;
            renameProvider: boolean;
        };
    };
    onDidOpenTextDocument: (params: any) => Promise<void>;
    onDidChangeTextDocument: (params: any) => Promise<void>;
    onDidCloseTextDocument: (params: any) => Promise<void>;
    onDocumentFormatting(params: DocumentRangeFormattingParams): TextEdit[];
    onDocumentSymbol(params: DocumentSymbolParams): any[];
    executeCommand(params: ExecuteCommandParams, executeCommandExported: any): any;
    onHover(params: TextDocumentPositionParams): Promise<any>;
    resovleSchema(url: string): Promise<string>;
    resolveCompletion(item: CompletionItem): Thenable<any>;
    onCompletion(params: TextDocumentPositionParams): Thenable<any>;
    getJSONDocument(document: any): JSONDocument;
    private getOpenDocument;
    onDefinition(): {
        uri: string;
        range: {
            line: number;
            character: number;
        };
    };
}
