// import { injectable, inject } from 'inversify';
// import * as fs from 'fs';
// import { xhr, XHRResponse, getErrorStatusDescription } from 'request-light';
// import URI from 'vscode-uri';
// import { IConnection } from 'vscode-languageserver';
// import {
//   TextDocument, Diagnostic, CompletionList, CompletionItem, Hover,
//   SymbolInformation, DocumentSymbolParams, TextEdit,
// } from 'vscode-languageserver-types';
// import { getLanguageService, LanguageService, YAMLDocument } from 'vscode-yaml-languageservice';
// import { TextDocumentPositionParams, DocumentRangeFormattingParams } from 'vscode-base-languageclient/lib/protocol';
// import { AbstractService } from './abstract-service';

// @injectable()
// export class YamlService extends AbstractService {

//   protected readonly yamlService: LanguageService = getLanguageService({
//       schemaRequestService: this.resovleSchema.bind(this),
//   });

//   protected readonly pendingValidationRequests = new Map<string, number>();

//   constructor(
//       protected readonly connection: IConnection,
//   ) {
//       super(connection);
//       this.documents.onDidChangeContent(change =>
//           this.validate(change.document),
//       );
//       this.documents.onDidClose(event => {
//           this.cleanPendingValidation(event.document);
//           this.cleanDiagnostics(event.document);
//       });

//       this.connection.onInitialize(params => {
//           this.connection.console.log('The yalm server is initialized.');
//           return {
//               capabilities: {
//                   textDocumentSync: this.documents.syncKind,
//                   codeActionProvider: true,
//                   completionProvider: {
//                       resolveProvider: true,
//                       triggerCharacters: ['', ':'],
//                   },
//                   hoverProvider: true,
//                   documentSymbolProvider: true,
//                   documentRangeFormattingProvider: true,
//               },
//           };
//       });

//       this.connection.onCompletion(params =>
//           this.completion(params),
//       );
//       this.connection.onCompletionResolve(item =>
//           this.resolveCompletion(item),
//       );

//       this.connection.onHover(params =>
//           this.hover(params),
//       );
//       this.connection.onDocumentSymbol(params =>
//           this.findDocumentSymbols(params),
//       );
//       this.connection.onDocumentRangeFormatting(params =>
//           this.format(params),
//       );
//   }

//   protected format(params: DocumentRangeFormattingParams): TextEdit[] {
//       const document = this.documents.get(params.textDocument.uri);
//       return this.yamlService.format(document, params.options);
//   }

//   protected findDocumentSymbols(params: DocumentSymbolParams): SymbolInformation[] {
//       const document = this.documents.get(params.textDocument.uri);
//       const yamlDocument = this.getYAMLDocument(document);
//       return this.yamlService.findDocumentSymbols(document, yamlDocument);
//   }

//   protected hover(params: TextDocumentPositionParams): Thenable<Hover> {
//       const document = this.documents.get(params.textDocument.uri);
//       const yamlDocument = this.getYAMLDocument(document);
//       return this.yamlService.doHover(document, params.position, yamlDocument);
//   }

//   protected resovleSchema(url: string): Promise<string> {
//       const uri = Uri.parse(url);
//       if (uri.scheme === 'file') {
//           return new Promise<string>((resolve, reject) => {
//               fs.readFile(uri.fsPath, 'UTF-8', (err, result) => {
//                   err ? reject('') : resolve(result.toString());
//               });
//           });
//       }
//       return xhr({ url, followRedirects: 5 }).then(response => {
//           return response.responseText;
//       }, (error: XHRResponse) => {
//           return Promise.reject(error.responseText || getErrorStatusDescription(error.status) || error.toString());
//       });
//   }

//   protected resolveCompletion(item: CompletionItem): Thenable<CompletionItem> {
//       return this.yamlService.doResolve(item);
//   }

//   protected completion(params: TextDocumentPositionParams): Thenable<CompletionList> {
//       const document = this.documents.get(params.textDocument.uri);
//       const yamlDocument = this.getYAMLDocument(document);
//       return this.yamlService.doComplete(document, params.position, yamlDocument);
//   }

//   protected validate(document: TextDocument): void {
//       this.cleanPendingValidation(document);
//       this.pendingValidationRequests.set(document.uri, setTimeout(() => {
//           this.pendingValidationRequests.delete(document.uri);
//           this.doValidate(document);
//       }));
//   }

//   protected cleanPendingValidation(document: TextDocument): void {
//       const request = this.pendingValidationRequests.get(document.uri);
//       if (request !== undefined) {
//           clearTimeout(request);
//           this.pendingValidationRequests.delete(document.uri);
//       }
//   }

//   protected doValidate(document: TextDocument): void {
//       if (document.getText().length === 0) {
//           this.cleanDiagnostics(document);
//           return;
//       }
//      const yamlDocument = this.getYAMLDocument(document);
//       this.yamlService.doValidation(document, yamlDocument).then(diagnostics =>
//           this.sendDiagnostics(document, diagnostics),
//       );
//   }

//   protected cleanDiagnostics(document: TextDocument): void {
//       this.sendDiagnostics(document, []);
//   }

//   protected sendDiagnostics(document: TextDocument, diagnostics: Diagnostic[]): void {
//       this.connection.sendDiagnostics({
//           uri: document.uri, diagnostics,
//       });
//   }

//   protected getYAMLDocument(document: TextDocument): YAMLDocument {
//       return this.yamlService.parseYAMLDocument(document);
//   }
// }
